// TASK 06

package task06;

import java.util.Stack;

// The method eval evaluates a given boolean expression in
// postfix notation. The following characters are used:

// '0': this character represents the boolean value false
// '1': this character represents the boolean value true
// 'c': this character represents conjunction
// 'd': this character represents disjunction
// 'n': this character represents negation

// Example:
// Consider the following boolean expression in postfix notation:
// char [] exp = {'0', '1', 'd', 'n'};
// 
// This expression corresponds to the following boolean expression:
// NOT ( FALSE OR TRUE )
//
// Therefore, eval(exp) should return the boolean value false.

public class Eval {

	public static boolean eval(char[] expression) {

		Stack<Boolean> intermediate = new Stack<Boolean>();

		for (char next : expression) {
			switch (next) {
			case '0': {
				intermediate.push(false);
				break;
			}
			case '1': {
				intermediate.push(true);
				break;
			}
			case 'd': {
				boolean op1 = intermediate.pop();
				boolean op2 = intermediate.pop();
				intermediate.push(op1 || op2);
				break;
			}
			case 'c': {
				boolean op1 = intermediate.pop();
				boolean op2 = intermediate.pop();
				intermediate.push(op1 && op2);
				break;
			}
			case 'n': {
				intermediate.push(!intermediate.pop());
				break;
			}
			default:
				throw new IllegalArgumentException();
			}
		}
		if (intermediate.size() == 1) {
			return intermediate.pop();
		} else
			throw new IllegalArgumentException();
	}
}
